<template lang="pug">
  div
    .columns(style="margin-top:30px;")
      .col-11.col-mx-auto.corpus-title.corpus-padding
        h1 {{ corpus.title }}

    //- If no authors, display owners instead.
    .col-11.col-mx-auto.grid.text-left.corpus-padding(v-if="corpus.authors && corpus.authors.length > 0")
      .authors {{ $t('by') }} 
        tippy(
          v-for="author in corpus.authors"
          v-if="author.affiliation"
          :to="author.name"
          :key="author.name"
        )
          b Affiliation:
          span {{ author.affiliation }}
        nuxt-link.chip.c-hand(
          v-for="author in corpus.authors"
          :name="author.name"
          :key="author.name"
          :to="{ path: localePath('home'), query: { tag: JSON.stringify({ name: author.name, type: 'author', filtervalue: author.name }) } }"
        ).
          {{ author.name }} #[span.ml-1(v-if="author.role") ({{ author.role }})]
    .col.col-mx-auto.grid.text-left.corpus-padding(v-else-if="corpus.actor")
      .authors {{ $t('by') }}
        avatar-chip(
          :actor="corpus.actor"
        )

    .col.col-mx-auto.grid.text-left.mb-10
      .d-flex.mt-2
        corpus-actions.col-mr-auto(
          v-if="isAuthenticated && corpus.actor && corpus.actor.username === getActorOrId || isAdministrator"
          :corpus="corpus"
          @afterDelete="() => $router.push(this.localePath('home'))"
          line
        )
        .col-mr-auto(v-else)
        //- Tools button
        md-button.md-dense(@click="toggleToolsModal" style="margin:6px 8px;")
          md-icon timeline
          span.ml-1 Tools

        //- Tools modal
        z-modal.modal(:open.sync="openToolsModal" title="Tools available for this corpus" size="md")
          div(v-for="tool in openToolsInput ? filterBy(tools, openToolsInput) : tools")
            a(:href="tool.url" target="_blank") {{ tool.name }}
            .ml-2.text-gray {{ tool.description }}
            .ml-2
              label Input formats 
              span.text-gray {{ tool.mimetypes.join(', ') }}
            .divider

          template(slot="footer")
            .d-flex
              input.mt-10.form-input(type="text" v-model="openToolsInput" placeholder="Search tools")
              md-button(@click="toggleToolsModal") {{ $t('close') }}

        //- Citation button
        md-menu(md-size="auto" md-direction="bottom-end" style="margin:6px 8px;")
          md-button.md-dense(md-menu-trigger)
            md-icon format_quote
            span.ml-1 Cite
          md-menu-content
            md-menu-item(@click="toggleCiteModal")
              span Plain text
            md-menu-item(:href="`${baseURL}/corpus/${routeParam}.bib`")
              span BibTex
              span.ml-2 (.bib)
            md-menu-item(:href="`${baseURL}/corpus/${routeParam}.ris`")
              span RIS
              span.ml-2 (.ris)
            md-menu-item(:href="`${baseURL}/corpus/${routeParam}.endnote`")
              span EndNote
              span.ml-2 (.endnote)
            md-menu-item(:href="`${baseURL}/corpus/${routeParam}.dc`")
              span Dublin Core
              span.ml-2 (.dc)
          //-
            md-menu-item(:href="`https://www.mendeley.com/import/?url=${baseURL}/corpus/${routeParam}`")
              span Mendeley
              md-icon launch
            md-menu-item(:href="`http://twitter.com/share?url=${baseURL}/corpus/${routeParam}`")
              span Twitter
              md-icon launch
        //- TODO: add when implemented on the backend
          md-button.md-dense
            md-icon playlist_add
            span.ml-1 Save To Library
          md-button.md-dense
            md-icon add_alert
            span.ml-1 Create Alert
          md-button.md-dense
            md-icon outlined_flag
            span.ml-1 Report

        //- Citation modal
        z-modal.modal(:open.sync="openCiteModal" title="How to cite this corpus" size="md")
          label Text
          blockquote.text-italic #[span(v-for="author in corpus.authors") {{ author.name }};], {{ $d(new Date(corpus.originalPublicationAt), 'short') }}, "{{ corpus.title }}", {{ getInstanceName | placeholder('via OLKi') }}, {{ `${baseURL}/corpus/${routeParam}` }}

          label BibTex
          blockquote(v-html="bib")

          template(slot="footer")
            md-button(@click="toggleCiteModal") {{ $t('close') }}
          
      .divider

    centered-fifty-fifty
      .columns
        .description
          small.text-gray {{ $t('description') | capitalize }}
          .markdown(v-show="corpus.description" v-html="descriptionHtml")
          .divider
          small.text-gray Licensed under
          div(v-if="!corpus.license").
            The corpus doesn't provide a license. Contact the author directly to know about its permitted reuse.
          div(v-else-if="corpus.license.includes('other')").
            waiver in the LICENSE file, corresponding to #[span {{ license.name }}]
          div(v-else)
            a(:href="`http://spdx.org/licenses/${corpus.license}.html`" target="_blank") {{ license.name }}
          .divider
          small.text-gray {{ $tc('language') }}
          div
            nuxt-link.text.c-hand(
              :to="{ path: localePath('home'), query: { tag: JSON.stringify({ name: corpusLanguageName.name, type: 'lang', filtervalue: corpusLanguageName.code }) } }"
            ) {{ corpusLanguageName.name }}
          div.tags(v-if="corpus.tags && corpus.tags.length > 0")
            .divider
            small.text-gray {{ $tc('tag', 2) | capitalize }}
            br
            nuxt-link.chip.c-hand(
              v-for="tag in corpus.tags"
              :key="tag.code"
              :to="{ path: localePath('home'), query: { tag: JSON.stringify({ name: tag.name, type: 'tag', filtervalue: tag.code }) } }"
              :class="{ category: types.find(type => type.name == tag.name) }"
            ) {{ tag.name | capitalize }}
          .divider
          small.text-gray(v-if="corpus.originalPublicationAt").
            {{ $t('original publication at') | lowercase }} {{ $d(new Date(corpus.originalPublicationAt), 'short') }} #[br]
          small.text-gray.
            {{ $t('deposited') | lowercase }} {{ $d(new Date(corpus.createdAt), 'short') }} · 
            {{ $t('last updated') | lowercase }} #[timeago(:datetime="new Date(corpus.updatedAt)" :auto-update="20")]

        .description(v-if="(corpus.related && corpus.related.length > 0) || corpus.digitalObjectIdentifier || corpus.clonedFrom")
          small.text-gray {{ $tc('relation', 2) | capitalize }}
          div(v-if="corpus.clonedFrom")
            .divider
            span is cloned from 
            a(:href="corpus.clonedFrom" target="_blank")
              img(:src="`https://img.shields.io/badge/HAL-${corpus.clonedFrom.split('/').pop().split('-')[1]}-lightgrey.svg`" alt="Repository")
          div(v-for="relation in corpus.related" :key="relation.link").
            {{ $t(relation.relation) }} #[a(:href="relation.link" target="_blank") {{ relation.link }}] #[br]
          div(v-if="corpus.digitalObjectIdentifier")
            .divider
            span is permanently identified as 
            a(:href="`https://dx.doi.org/${tailOfDOI}`" target="_blank")
              img(:src="`https://img.shields.io/badge/DOI-${tailOfDOI.split('-')[0]}-lightgrey.svg`" alt="DOI")

      .columns
        .bloc-header.d-flex(v-if="corpus.files.length == 0")
          span {{ $tc('file') | capitalize({ onlyFirstLetter: true }) }}
        .bloc-header.d-flex(v-else)
          span.col-mr-auto {{ $tc('file', corpus.files.length + 1) | capitalize({ onlyFirstLetter: true }) }} ({{ corpus.files.length }})
          md-button.md-hyperdense(
            :href="`${getOriginCorpusUrl(corpus)}.zip`"
          )
            | #[span.mr-1 Download all] 
            md-icon archive
        .description.mt-15(v-if="corpus.files.length == 0")
          .text-center(v-if="corpus.clonedFrom")
            a(:href="`${corpus.clonedFrom}/document`" target="_blank") See file(s) on distant repository #[i.material-icons(style="font-size:0.8rem;") launch]
          .text-center(v-else) This corpus has no file.
        .files.mt-15(v-else)
          md-list.md-double-line
            md-list-item(
              v-for="file in corpus.files"
              :key="file.name"
            )
              md-icon(v-if="file.filetype.startsWith('video')") movie
              md-icon(v-else-if="file.filetype.startsWith('application/pdf')") picture_as_pdf
              md-icon(v-else-if="file.filetype.startsWith('image')") image
              md-icon(v-else) insert_drive_file
              .md-list-item-text
                a(:href="getFileUrl(file)" download) {{ file.name }}
                span {{ file.size | prettyBytes }}
              md-menu.md-list-action(md-size="auto" md-direction="bottom-end")
                md-button.md-icon-button(md-menu-trigger)
                  md-icon menu
                md-menu-content
                  md-menu-item(:href="getFileUrl(file)" download)
                    span Download
                    md-icon get_app
                  md-menu-item.c-hand(v-clipboard="file.hash")
                    span Copy md5
                    md-icon file_copy

        .bloc-header.d-flex
          dropdown-button(
            style="height:initial;position:relative;top:-0.25rem;left:-0.25rem;"
          ) {{ $tc(activityFilter, 2) | capitalize({ onlyFirstLetter: true }) }} #[i.material-icons(tabindex="-1" style="font-size:0.9rem;") filter_list]
            template(slot="container")
              li.menu-item
                a.menu-item(:class="{ active: activityFilter == 'comment' }" @click="() => activityFilter = 'comment'")
                  small only show comments
              li.menu-item
                a.menu-item(:class="{ active: activityFilter == 'modification' }" @click="() => activityFilter = 'modification'")
                  small only show modifications
              li.menu-item
                a.menu-item(:class="{ active: activityFilter == 'activity' }" @click="() => activityFilter = 'activity'")
                  small show all
          md-button.col-ml-auto.mr-2.mt-2.md-hyperdense(
            style="font-size-adjust:0.5"
            v-if="isAuthenticated && corpus.commentsAllowed"
            v-shortkey.once="['n']"
            @shortkey.native="() => writingComment = true"
            @click="() => writingComment = true"
          )
            | #[span.mr-1 add a comment] 
            md-icon add_comment

        //- The comment requires an id to save its state and differentiate sessions per corpus
        div.mt-15(v-if="isAuthenticated && corpus.commentsAllowed")
          comment-form(
            v-if="writingComment"
            :id="corpus.pk"
            :refetchQueries="refetchQueries"
            @cancel="() => writingComment = false"
          )
        .description.mt-15(v-else-if="corpus.commentsAllowed")
          .text-center {{ $t('corpus commenting note to external') }}
        .description.mt-15(v-else)
          .text-center {{ $t('corpus commenting closed') }}
        .timeline
          .timeline-item(
            v-for="activity in aggregatedActions"
            :id="activity.pk"
            :class="{ 'timeline-item-last': activity.pk === aggregatedActions[aggregatedActions.length - 1].pk }"
          )
            .timeline-left
              a.timeline-icon(:href="'#' + activity.pk")
            .timeline-content
              activity(:activity="activity" :refetchQueries="refetchQueries" corpus :corpusPk="corpus.pk")

</template>

<script>
import Vue from 'vue'
import { mapGetters, mapState } from 'vuex'
import VueTimeago from 'vue-timeago'

import snarkdown from 'snarkdown'
import Vue2Filters from 'vue2-filters'

import languages from '~/assets/data/languages.js'
import { licenses } from '~/assets/data/licenses.json'
import types from '~/assets/data/corpusTypes.js'

import exactCorpusGql from '~/apollo/queries/exactCorpus'
import listActivitiesForCorpusGql from '~/apollo/queries/listActivitiesForCorpus'
import { parseCorpus } from '~/apollo/queryBuilderCorpus'

import CorpusActions from '~/components/CorpusActions'
import Activity from '~/components/Activity'
import AvatarChip from '~/components/AvatarChip'
import DropdownButton from '~/components/DropdownButton'
import CommentForm from '~/components/CommentForm'
import CenteredFiftyFifty from '~/components/sublayouts/CenteredFiftyFifty.vue'

import environment from '~/mixins/environment'

const currentLicenses = licenses
currentLicenses.push(
  { licenseId: 'other-open', name: 'Other (Open)' },
  { licenseId: 'other-attribution', name: 'Other (Attribution)' },
  { licenseId: 'other-non-commercial', name: 'Other (Non-Commercial)' },
  { licenseId: 'other-not-open', name: 'Other (Not Open)' },
  { licenseId: 'other-public-domain', name: 'Other (Public Domain)' }
)

Vue.use(VueTimeago, {
  name: 'Timeago'
})

export default {
  components: {
    // layout components:
    CenteredFiftyFifty,
    // logic components:
    Activity,
    AvatarChip,
    CommentForm,
    CorpusActions,
    DropdownButton,
    VueTimeago
  },
  mixins: [environment, Vue2Filters.mixin],
  data() {
    return {
      routeParam: this.$route.params.id,
      corpus: {
        description: ''
      },
      actions: {
        edges: []
      },
      writingComment: false,
      types,
      openCiteModal: false,
      activityFilter: 'activity',
      openToolsModal: false,
      openToolsInput: '',
      tools: []
    }
  },
  head() {
    return {
      title: `${this.getInstanceName} - Corpus - ${this.corpus.title}`,
      link: [
        {
          rel: 'alternate',
          href: `${this.$route.path}.bib`,
          type: 'application/x-bibtex'
        },
        {
          rel: 'alternate',
          href: `${this.$route.path}.ris`,
          type: 'application/x-research-info-systems'
        },
        {
          rel: 'alternate',
          href: `${this.$route.path}.endnote`,
          type: 'application/x-bibliographic'
        },
        {
          rel: 'alternate',
          href: `${this.$route.path}.dc`,
          type: 'application/dc+xml'
        }
      ]
    }
  },
  computed: {
    descriptionHtml() {
      return snarkdown(this.corpus.description)
    },
    license() {
      return (
        licenses.find(license => license.licenseId === this.corpus.license) ||
        false
      )
    },
    corpusLanguageName() {
      return (
        languages.find(lang => lang.code === this.corpus.language) || {
          name: this.corpus.language
        }
      )
    },
    ...mapGetters('user', ['getActorOrId']),
    ...mapState('auth', ['isAuthenticated']),
    ...mapGetters('user', ['isAdministrator']),
    ...mapGetters('instance', ['getInstanceName']),
    aggregatedActions() {
      /* eslint-disable */
      return this.actions.edges // not modifying anything for now, but ready to rearrange the list if need be
    },
    tailOfDOI() {
      return this.corpus.digitalObjectIdentifier
        ? this.corpus.digitalObjectIdentifier.replace(/^.*\/\/[^\/]+\//, '')
        : ''
    },
    refetchQueries() {
      return [
        {
          query: listActivitiesForCorpusGql,
          variables: {
            pk: this.corpus.pk,
            first: 15,
            onlyComments: this.activityFilter === 'comment' ? true : null,
            onlyModifications:
              this.activityFilter === 'modification' ? true : null
          }
        }
      ]
    }
  },
  apollo: {
    actions: {
      query: listActivitiesForCorpusGql,
      fetchPolicy: 'network-only',
      //pollInterval: 60*1000, // 60s
      variables() {
        return {
          pk: this.routeParam,
          first: 15,
          onlyComments: this.activityFilter === 'comment' ? true : null,
          onlyModifications:
            this.activityFilter === 'modification' ? true : null
        }
      },
      update: data => {
        if (!data.activitiesCorpus) return {}
        return {
          ...data.activitiesCorpus,
          edges: data.activitiesCorpus.edges.map(edge => edge.node)
        }
      }
    }
  },
  async asyncData({ app, error, params, $axios }) {
    const getCorpus = async (first = true) => await app.apolloProvider.defaultClient
      .query({
        query: exactCorpusGql,
        variables: { pk: params.id },
        fetchPolicy: 'network-only'
      })
      .then(({ data }) => parseCorpus(data.corpus))
      .catch(e => {
        if (first) return getCorpus(false) // retry once
        error({ statusCode: 404, message: 'corpus' })
      })

    const corpus = await getCorpus()
    const bib = (await $axios.$get(`/corpus/${params.id}.bib`))
      .replace(/^(?:\n)/g, '')
      .replace(/(?:\r\n|\r|\n)/g, '<br />')
    return {
      corpus,
      bib
    }
  },
  methods: {
    getOriginCorpusUrl(corpus) {
      return corpus.isRemote
        ? `${corpus.actor.fullUsername.split('@')[1]}/corpus/${this.routeParam}`
        : `${this.baseURL}/corpus/${this.routeParam}`
    },
    getFileUrl(file) {
      return file.url.startsWith('http')
        ? file.url
        : `${this.baseURL}/media/${file.url}`
    },
    toggleCiteModal() {
      this.openCiteModal = !this.openCiteModal
    },
    async toggleToolsModal() {
      this.openToolsModal = !this.openToolsModal
      this.tools = await this.$axios.$get(
        'https://beta-switchboard.clarin.eu/api/tools?deployment=development&sortBy=tools'
      )
      if (this.tools) {
        this.tools = this.tools.filter(tool => tool.authentication === 'no')
        if (this.corpus.languge) {
          this.tools = this.tools.filter(tool =>
            tool.languages.find(lang => lang.includes(this.corpus.language))
          )
        }
      }
    }
  }
}
</script>

<style lang="postcss" scoped>
.pagecontainer {
  height: 100%;
  margin-top: 0;
}
.grid {
  height: 100%;
  display: grid;
  max-width: 960px;
  align-items: flex-end;
}
.columns {
  flex-direction: column;
  text-align: left;
}
.corpus-padding {
  padding-left: 20px;
  padding-right: 6px;
}
.description,
.files {
  background: rgb(var(--color-foreground));
  border-radius: 4px;
  margin-bottom: 25px;
  width: 100%;
  padding-left: 20px;
  padding-right: 20px;

  overflow: hidden;
  word-break: break-word;
}
.description {
  padding: 20px;
}
.bloc-header {
  height: 20px;

  .md-button {
    position: relative;
    top: calc(-50%);

    &.md-hyperdense {
      top: calc(-50% + 2px);
      height: 24px;
      font-size: 0.65rem;
    }
  }
}
.md-list-item {
  margin-top: 0;
}
.chip {
  max-width: max-content;
}
.authors {
  float: left;

  .chip {
    color: rgb(var(--color-text)) !important;
    text-decoration: none;
  }
}
.corpus-title {
  max-width: 960px;
  align-items: center;
  display: flex;
  justify-content: space-between;
}
.tags {
  overflow: hidden;
}
</style>
